Attribute VB_Name = "modAnagrammi"
'==============================================================
' Descrizione.....: Calcolo delle permutazioni distinte con
'                   oggetti ripetuti (anagrammi).
' Nome dei Files..: modAnagrammi.bas
'                   CalcComb.bas
' Data............: 12/2/2002
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 sotto Windows NT.
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.virgilio.it/flanguasco/
'==============================================================
'   Comprende:
'
'    PermutazioniDR:    Trova le permutazioni distinte, con oggetti
'                       ripetuti, dei valori contenuti in un vettore.
'
'    Pdr:               Ritorna il numero delle permutazioni distinte,
'                       con oggetti ripetuti, dei valori contenuti in
'                       un vettore.
'
'    Anagramma:         Trova gli anagrammi distinti che si possono
'                       comporre con i caratteri di una Frase$.
'
'    NAnagrammi:        Ritorna il numero di anagrammi distinti che si
'                       possono comporre con i caratteri di una Frase$.
'
'   Nota:   Tutti i valori contenuti nei vettori da anagrammare o da
'           analizzare devono essere >= 0.
'
'   Nota:   Tutti i vettori e le matrici di queste
'           routines iniziano dall' indice 1.
'
'   Routines tratte e tradotte dal programma in C:
'    *******************************************************
'    *                                                     *
'    *                      ANAGRAMS                       *
'    *                                                     *
'    *           by Adriano Nagelschmidt Rodrigues         *
'    *                 Email: anr@ime.usp.br               *
'    *                 Web: http://www.ime.usp.br/~anr/    *
'    *                                                     *
'    *******************************************************
'
Option Explicit
'
Private MAXS&       ' Vedi programma in C Anag_op.txt
Private cr&()       '   "      "      "        "
Private q&()        '   "      "      "        "
Private R&()        '   "      "      "        "
Private h&          '   "      "      "        "
Private num&        '   "      "      "        "
'
Private PrmDR&()    ' Matrice di accumulo delle permutazioni trovate.
'
Private Const Overflow& = 6 ' Codice dell' errore di "overflow".
Private Sub AddChr(ByVal L&, ByVal C&)
'
'   This function adds character c at the end of string R:
'
    Dim I&
'
    For I = 1 To MAXS
        If R(L, I) < 0 Then
            R(L, I) = C
            R(L, I + 1) = -1
            Exit Sub
        End If
    Next I
'
'
'
End Sub
Private Sub Anagram(ByVal L&)
'
'   This recursive function does the whole thing.
'   It parses each and every branch of a tree-like structure:
'
    Dim I&
'
    If L > 1 Then
        For I = 1 To L
            If Not_StrChr(L, q(L, I)) Then
                cr(h) = q(L, I)
                h = h + 1
                Cut L, I
                Anagram L - 1
                h = h - 1
                AddChr L, q(L, I)
            End If
        Next I
        R(L, 1) = -1
    Else
        cr(h) = q(L, 1)
        num = num + 1
'
        For I = 1 To MAXS - 1
            PrmDR(num, I) = cr(I)
        Next I
    End If
'
'
'
End Sub
Private Sub Cut(ByVal L&, ByVal Pos&)
'
'   This function cuts the character in <pos> position
'   from the q[l] string:
'
    Dim I&, i1&, o1&
'
    i1 = 1
    o1 = 1
    For I = 1 To L
        If I = Pos Then i1 = i1 + 1
        q(L - 1, o1) = q(L, i1)
        i1 = i1 + 1
        o1 = o1 + 1
    Next I
'
'
'
End Sub
Public Function Anagramma(ByVal Frase$, AnagrammiD$()) As Boolean
'
'   Ritorna, nel vettore AnagrammiD$(), gli anagrammi distinti
'   degli L caratteri di Frase$.
'
    Dim L&, I&, J&, Oggetti&(), PermuDR&()
    ReDim AnagrammiD$(1 To 1)
'
    L = Len(Frase$)
    ReDim Oggetti(1 To L)
'
    ' Converte i caratteri di Frase$ in
    ' valori del vettore Oggetti():
    For I = 1 To L
        Oggetti(I) = Asc(Mid$(Frase$, I, 1))
    Next I
'
    If PermutazioniDR(Oggetti(), PermuDR()) Then
        Anagramma = True
'
        ' Riconverte le permutazioni
        ' trovate in anagrammi di Frase$:
        For J = 1 To num
            ReDim Preserve AnagrammiD$(1 To J)  ' E' piu' veloce cosi', piuttosto che
                                                ' definire inizialmente, fuori dal For:
                                                ' ReDim AnagrammiD$(1 To num) !!
            For I = 1 To L
                AnagrammiD$(J) = AnagrammiD$(J) & Chr$(PermuDR(J, I))
            Next I
        Next J
'
    Else
        Anagramma = False
    End If
'
'
'
End Function
Public Function PermutazioniDR(Oggetti&(), PermuDR&()) As Boolean
'
'   Ritorna, nella matrice PermuDR(), le permutazioni distinte, con
'   oggetti ripetuti, degli L valori contenuti nel vettore Oggetti().
'
    Dim L&, I&, J&
'
    On Error GoTo PermutazioniDR_ERR
'
    L = UBound(Oggetti)
    ReDim PrmDR(1 To Pdr(Oggetti()), 1 To L)
'
    MAXS = L + 1
    ReDim cr(1 To MAXS - 1)
    ReDim q(1 To MAXS, 1 To MAXS)
    ReDim R(1 To MAXS, 1 To MAXS)
'
    For J = 1 To MAXS
        For I = 1 To MAXS
            q(J, I) = -1
            R(J, I) = -1
        Next I
    Next J
'
    For I = 1 To L
        q(L, I) = Oggetti(I)
    Next I
'
    h = 1
    num = 0
'
    Anagram L
'
    PermuDR() = PrmDR()
'
'
PermutazioniDR_ERR:
    PermutazioniDR = (Err = 0)
    If (Err <> 0) Then
        Dim M$
        M$ = "Err. N " & Err.Number & "  " & Err.Description & vbNewLine
        MsgBox M$, vbCritical, " Function PermutazioniDR"
    End If
'
'
'
End Function
Public Function NAnagrammi(ByVal Frase$) As Long
'
'   Ritorna il numero di anagrammi distinti che si
'   possono comporre con i caratteri di Frase$:
'
    Dim I&, N&, C$, NAna#
'
    On Error GoTo NAnagrammi_ERR
'
    NAna = Prodotto(Len(Frase$))
'
    Do While Len(Frase$) > 0
        N = 1
        C$ = Left$(Frase$, 1)
        For I = 2 To Len(Frase$)
            If C$ = Mid$(Frase$, I, 1) Then
                N = N + 1
            End If
        Next I
        Frase$ = Replace(Frase$, C$, "")
        NAna = NAna / Prodotto(N)
    Loop
'
    NAnagrammi = CLng(NAna)
    Exit Function
'
'
NAnagrammi_ERR:
    Dim M$
    NAnagrammi = 0
    M$ = "Err. N " & Err.Number & "  " & Err.Description & vbNewLine
    If (Err = Overflow) Then
        M$ = M$ & "Il numero di anagrammi e' troppo grande." & vbNewLine
    End If
    MsgBox M$, vbCritical, " Function NAnagrammi"
'
'
'
End Function
Private Function Not_StrChr(ByVal L&, ByVal C&) As Boolean
'
'   Inverso (ed adattamento agli scopi di questo
'   programma) della funzione strchr del C:
'
    Dim I&
'
    For I = 1 To MAXS
        If R(L, I) < 0 Then Exit For
        If R(L, I) = C Then
            Not_StrChr = False
            Exit Function
        End If
    Next I
'
    Not_StrChr = True
'
'
'
End Function
Public Function Pdr(Oggetti&()) As Long
'
'   Ritorna il numero di permutazioni distinte che si possono
'   comporre con i valori (anche ripetuti ma >= 0) del vettore
'   Oggetti():
'
    Dim I&, J&, N&, K&, lOgg&(), NAna#
'
    On Error GoTo Pdr_ERR
'
    ' Fa' una copia del vettore
    ' Oggetti() per non rovinarlo:
    lOgg() = Oggetti()
'
    NAna = Prodotto(UBound(lOgg))
'
    For J = 1 To UBound(lOgg) - 1
        If lOgg(J) >= 0 Then
            N = 1
            K = lOgg(J)
            For I = J + 1 To UBound(lOgg)
                If K = lOgg(I) Then
                    N = N + 1
                    lOgg(I) = -1
                End If
            Next I
            NAna = NAna / Prodotto(N)
        End If
    Next J
'
    Pdr = CLng(NAna)
    Exit Function
'
'
Pdr_ERR:
    Dim M$
    Pdr = 0
    M$ = "Err. N " & Err.Number & "  " & Err.Description & vbNewLine
    If (Err = Overflow) Then
        M$ = M$ & "Il numero di permutazioni e' troppo grande." & vbNewLine
    End If
    MsgBox M$, vbCritical, " Function Pdr"
'
'
'
End Function
